/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.enums.EnumAccesslevel;
import de.ship.db.tables.TCorePerson.TCorePersonPath;
import de.ship.db.tables.TCorePrivilege.TCorePrivilegePath;
import de.ship.db.tables.records.TCoreUserprivilegeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreUserprivilege extends TableImpl<TCoreUserprivilegeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_userprivilege</code>
     */
    public static final TCoreUserprivilege T_CORE_USERPRIVILEGE = new TCoreUserprivilege();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreUserprivilegeRecord> getRecordType() {
        return TCoreUserprivilegeRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_userprivilege.lastchange</code>.
     */
    public final TableField<TCoreUserprivilegeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_userprivilege.pk</code>.
     */
    public final TableField<TCoreUserprivilegeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_userprivilege.fk_privilege</code>.
     */
    public final TableField<TCoreUserprivilegeRecord, Integer> FK_PRIVILEGE = createField(DSL.name("fk_privilege"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_userprivilege.fk_usnr</code>.
     */
    public final TableField<TCoreUserprivilegeRecord, Integer> FK_USNR = createField(DSL.name("fk_usnr"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_userprivilege.shippie_acl</code>.
     */
    public final TableField<TCoreUserprivilegeRecord, EnumAccesslevel> SHIPPIE_ACL = createField(DSL.name("shippie_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.t_core_userprivilege.shipdesigner_acl</code>.
     */
    public final TableField<TCoreUserprivilegeRecord, EnumAccesslevel> SHIPDESIGNER_ACL = createField(DSL.name("shipdesigner_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.t_core_userprivilege.square_acl</code>.
     */
    public final TableField<TCoreUserprivilegeRecord, EnumAccesslevel> SQUARE_ACL = createField(DSL.name("square_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.t_core_userprivilege.sam_acl</code>.
     */
    public final TableField<TCoreUserprivilegeRecord, EnumAccesslevel> SAM_ACL = createField(DSL.name("sam_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    private TCoreUserprivilege(Name alias, Table<TCoreUserprivilegeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreUserprivilege(Name alias, Table<TCoreUserprivilegeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_userprivilege</code> table
     * reference
     */
    public TCoreUserprivilege(String alias) {
        this(DSL.name(alias), T_CORE_USERPRIVILEGE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_userprivilege</code> table
     * reference
     */
    public TCoreUserprivilege(Name alias) {
        this(alias, T_CORE_USERPRIVILEGE);
    }

    /**
     * Create a <code>common_dd.t_core_userprivilege</code> table reference
     */
    public TCoreUserprivilege() {
        this(DSL.name("t_core_userprivilege"), null);
    }

    public <O extends Record> TCoreUserprivilege(Table<O> path, ForeignKey<O, TCoreUserprivilegeRecord> childPath, InverseForeignKey<O, TCoreUserprivilegeRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_USERPRIVILEGE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreUserprivilegePath extends TCoreUserprivilege implements Path<TCoreUserprivilegeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreUserprivilegePath(Table<O> path, ForeignKey<O, TCoreUserprivilegeRecord> childPath, InverseForeignKey<O, TCoreUserprivilegeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreUserprivilegePath(Name alias, Table<TCoreUserprivilegeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreUserprivilegePath as(String alias) {
            return new TCoreUserprivilegePath(DSL.name(alias), this);
        }

        @Override
        public TCoreUserprivilegePath as(Name alias) {
            return new TCoreUserprivilegePath(alias, this);
        }

        @Override
        public TCoreUserprivilegePath as(Table<?> alias) {
            return new TCoreUserprivilegePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_CORE_USERPRIVILEGE_PRIVILEGE, Indexes.IDX_USERPRIVILEGE_PRIVILEGE, Indexes.IDX_USERPRIVILEGE_USNR);
    }

    @Override
    public Identity<TCoreUserprivilegeRecord, Integer> getIdentity() {
        return (Identity<TCoreUserprivilegeRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreUserprivilegeRecord> getPrimaryKey() {
        return Keys.PK_CORE_USERPRIVILEGE;
    }

    @Override
    public List<UniqueKey<TCoreUserprivilegeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_USERPRIVILEGE);
    }

    @Override
    public List<ForeignKey<TCoreUserprivilegeRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_USERPRIVILEGE__FK_CORE_USERPRIVILEGE_PRIVILEGE, Keys.T_CORE_USERPRIVILEGE__FK_CORE_USERPRIVILEGE_USNR);
    }

    private transient TCorePrivilegePath _tCorePrivilege;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_privilege</code>
     * table.
     */
    public TCorePrivilegePath tCorePrivilege() {
        if (_tCorePrivilege == null)
            _tCorePrivilege = new TCorePrivilegePath(this, Keys.T_CORE_USERPRIVILEGE__FK_CORE_USERPRIVILEGE_PRIVILEGE, null);

        return _tCorePrivilege;
    }

    private transient TCorePersonPath _tCorePerson;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_person</code>
     * table.
     */
    public TCorePersonPath tCorePerson() {
        if (_tCorePerson == null)
            _tCorePerson = new TCorePersonPath(this, Keys.T_CORE_USERPRIVILEGE__FK_CORE_USERPRIVILEGE_USNR, null);

        return _tCorePerson;
    }

    @Override
    public TCoreUserprivilege as(String alias) {
        return new TCoreUserprivilege(DSL.name(alias), this);
    }

    @Override
    public TCoreUserprivilege as(Name alias) {
        return new TCoreUserprivilege(alias, this);
    }

    @Override
    public TCoreUserprivilege as(Table<?> alias) {
        return new TCoreUserprivilege(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUserprivilege rename(String name) {
        return new TCoreUserprivilege(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUserprivilege rename(Name name) {
        return new TCoreUserprivilege(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUserprivilege rename(Table<?> name) {
        return new TCoreUserprivilege(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUserprivilege where(Condition condition) {
        return new TCoreUserprivilege(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUserprivilege where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUserprivilege where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUserprivilege where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUserprivilege where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUserprivilege where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUserprivilege where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUserprivilege where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUserprivilege whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUserprivilege whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
